#ifndef LATENTEDITOR_H
#define LATENTEDITOR_H

#include <QtGui/QWidget>
#include <QGraphicsScene>
#include <QGraphicsItem>
#include <QPainter>

QT_BEGIN_NAMESPACE
  class QGraphicsSceneMouseEvent;
QT_END_NAMESPACE

//=================================================================================================
class Zacep : public QGraphicsItem
{
  public:
    enum { Type = UserType + 1 };
    int type() const { return Type; }

    Zacep();

    QRectF boundingRect() const;
    void paint( QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget );

  protected:
    void mousePressEvent( QGraphicsSceneMouseEvent *e );
    void mouseMoveEvent( QGraphicsSceneMouseEvent *e );
};
//=================================================================================================



//=================================================================================================
class GraphicsScene : public QGraphicsScene
{
  enum
  {
    CenterX = 300,
    CenterY = 460
  };

  float _180divPI;
  float PIdiv180;

  public:
    GraphicsScene( QWidget *parent = 0 );

  protected:
    void mousePressEvent( QGraphicsSceneMouseEvent *e );
    void mouseMoveEvent( QGraphicsSceneMouseEvent *e );
    float getVectorLength( float dx, float dy );
    float getDistanceBetweenPoints( float x1, float y1, float x2, float y2 );
};
//=================================================================================================



//=================================================================================================
class LatentEditor : public QWidget
{
  Q_OBJECT

  GraphicsScene *scene;
  QPen normalPen;
  QPen selectedPen;
  QPen dashPen;

  public:
    LatentEditor(QWidget *parent = 0);
    ~LatentEditor() {}
};
//=================================================================================================

#endif // LATENTEDITOR_H
